Bug 165384 - cpufreq driver hangs when using SMP Powernow
cpufreq driver hangs when using SMP Powernow
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Brian Maly
Brian Brock
:
Depends On:
Blocks: 156323 158844
  Show dependency treegraph
 
Reported: 2005-08-08 14:39 EDT by Brian Maly
Modified: 2007-11-30 17:07 EST (History)
0 users

See Also:
Fixed In Version: RHSA-2005-514
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-10-05 09:49:20 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch to resolve cpuspeed (cpufreq+powernow-k8) hang (802 bytes, patch)
2005-08-11 14:37 EDT, Brian Maly
no flags Details | Diff

  None (edit)
Description Brian Maly 2005-08-08 14:39:38 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux x86_64; rv:1.7.3) Gecko/20041020 Firefox/0.10.1

Description of problem:

The cpufreq driver works for a while but eventually hangs on systems using SMP Powernow. cpufreq.c has many SMP enablement fixes upstream such as per-cpu reference count, etc that are likely required for SMP powernow.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1. modprobe powernow-k8 on an SMP Powernow capable system
2. start cpuspeed
3. kill cpuspeed when hung (it wont die... now a zombie)
  

Actual Results:  cpuspeed runs for a while but eventually hangs (strace reveals it hangs when trying to read from a cpufreq related file in /sys). cpuspeed never gets a chance to update CPU frequencies (this hang happens in the first 60 seconds). cpuspeed hangs and cant be killed. any process that read/writes to these files in /sys hang as well.

Expected Results:  cpuspeed should shift between frequencies and keep running. reading and writing to the cpuspeed specific /sys files should not cause a process to hang. cpuspeed should die if killed.

Additional info:
Comment 1 Brian Maly 2005-08-08 14:59:22 EDT
this should be a MUSTFIX for U2 being that we wont have SMP Powernow enablement
without these enhancements
Comment 3 Brian Maly 2005-08-11 14:37:26 EDT
Created attachment 117656 [details]
patch to resolve cpuspeed (cpufreq+powernow-k8) hang

this patch was posted on 8/11/05 to rhkernel

Description:

Incremental patch to powernow-k8 v1.39 driver update BZ 160011

Some vendor testing exposed a few loose ends in the Powernow driver update,
specifically the cpuspeed daemon hanging and the ondemand and powersave
governor drivers failing to load. The problem was that the powernow-k8 module
was getting stuck in a few spots, causing the cpufreq module to hang, and thus
causing the cpuspeed daemon to hang (cpuspeed couldnt be killed once hung
either).

This patch resolves these issues as well as removing 1 unused variable (code
cleanup).

I did confirm that powernow-k8 now works correctly on SMP machines, cpuspeed no
longer hangs, and the ondemand and powersave modules now load as well.
Comment 5 Red Hat Bugzilla 2005-10-05 09:49:20 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2005-514.html

Note You need to log in before you can comment on or make changes to this bug.